"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GroupObserver = void 0;
const internal_1 = require("../../internal");
class GroupObserver extends internal_1.Observer {
    constructor(group, config = {}) {
        super(group.agileInstance(), Object.assign(Object.assign({}, config), { value: group._output }));
        this.group = () => group;
        this.nextGroupOutput = internal_1.copy(group._output);
    }
    ingest(config = {}) {
        this.group().rebuild(config);
    }
    ingestItems(newGroupItems, config = {}) {
        var _a;
        const group = this.group();
        config = Object.assign({ perform: true, background: false, sideEffects: {
                enabled: true,
                exclude: [],
            }, force: false, maxTriesToUpdate: 3 }, config);
        if (group.isPlaceholder) {
            config.force = true;
        }
        this.nextGroupOutput = internal_1.copy(newGroupItems.map((item) => {
            return item._value;
        }));
        if (internal_1.equal(group._output, this.nextGroupOutput) && !config.force)
            return;
        const job = new internal_1.RuntimeJob(this, {
            sideEffects: config.sideEffects,
            force: config.force,
            background: config.background,
            key: (_a = config.key) !== null && _a !== void 0 ? _a : `${this._key != null ? this._key + '_' : ''}${internal_1.generateId()}_output`,
            maxTriesToUpdate: config.maxTriesToUpdate,
        });
        this.agileInstance().runtime.ingest(job, {
            perform: config.perform,
        });
    }
    perform(job) {
        const observer = job.observer;
        const group = observer.group();
        group._output = internal_1.copy(observer.nextGroupOutput);
        job.observer.previousValue = internal_1.copy(job.observer.value);
        job.observer.value = internal_1.copy(group._output);
    }
}
exports.GroupObserver = GroupObserver;
