"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Observer = void 0;
const internal_1 = require("../internal");
class Observer {
    constructor(agileInstance, config = {}) {
        var _a, _b;
        this.dependents = new Set();
        this.subscribedTo = new Set();
        config = Object.assign({ dependents: [], subs: [] }, config);
        this.agileInstance = () => agileInstance;
        this._key = config.key;
        this.value = config.value;
        this.previousValue = config.value;
        (_a = config.dependents) === null || _a === void 0 ? void 0 : _a.forEach((observer) => this.addDependent(observer));
        (_b = config.subs) === null || _b === void 0 ? void 0 : _b.forEach((subscriptionContainer) => subscriptionContainer.addSubscription(this));
    }
    set key(value) {
        this._key = value;
    }
    get key() {
        return this._key;
    }
    ingest(config = {}) {
        var _a;
        config = Object.assign({ perform: true, background: false, sideEffects: {
                enabled: true,
                exclude: [],
            }, force: false }, config);
        const job = new internal_1.RuntimeJob(this, {
            force: config.force,
            sideEffects: config.sideEffects,
            background: config.background,
            key: (_a = config.key) !== null && _a !== void 0 ? _a : `${this._key != null ? this._key + '_' : ''}${internal_1.generateId()}`,
        });
        this.agileInstance().runtime.ingest(job, {
            perform: config.perform,
        });
    }
    perform(job) {
        internal_1.LogCodeManager.log('17:03:00');
    }
    addDependent(observer) {
        if (!this.dependents.has(observer))
            this.dependents.add(observer);
    }
    removeDependent(observer) {
        if (this.dependents.has(observer))
            this.dependents.delete(observer);
    }
}
exports.Observer = Observer;
